Summary: packet-sniffer/logger
Name: snort
Version: 1.9.1
Release: rh73_chroot1
Copyright: GPL
Group: Applications/Internet
Source0: http://www.snort.org/Files/%{name}-%{version}.tar.gz
Source1: snort-stat
Source2: snortlog
Source4: snortd-chroot
Url: http://www.snort.org
BuildRoot: /var/tmp/%{name}-root
Packager: Ralf Spenneberg <ralf@spenneberg.de> - OpenSource Security

%description
Snort is a libpcap-based packet sniffer/logger which 
can be used as a lightweight network intrusion detection system. 
It features rules based logging and can perform protocol analysis, 
content searching/matching and can be used to detect a variety of 
attacks and probes, such as buffer overflows, stealth port scans, 
CGI attacks, SMB probes, OS fingerprinting attempts, and much more. 
Snort has a real-time alerting capabilty, with alerts being sent to syslog, 
a seperate "alert" file, or as a WinPopup message via Samba's smbclient
This package has been compiled with Postgresql and Mysql Support.
Furthermore smbalerts, snmp, flexresponse and openssl have been turned on.
Keep in mind though, that all these plugins eat performance!
This Snort package has been modified to allow for a chrooted snort!
%prep
%setup -q 

%build
#CFLAGS="$RPM_OPT_FLAGS" \
autoconf
CPPFLAGS="-I/usr/kerberos/include" ./configure --prefix=/usr --bindir=/usr/sbin --sysconfdir=/etc/snort --enable-flexresp --enable-smbalerts --with-postgresql --with-mysql --with-openssl  --with-snmp  
aclocal
automake
make

%install
if [ "$RPM_BUILD_ROOT" = "/var/tmp/snort-root" ]; then
	rm -rf $RPM_BUILD_ROOT
	mkdir -p $RPM_BUILD_ROOT/chroot-snort/usr/bin
	mkdir -p $RPM_BUILD_ROOT/chroot-snort/usr/sbin
	mkdir -p $RPM_BUILD_ROOT/chroot-snort/usr/doc
	mkdir -p $RPM_BUILD_ROOT/chroot-snort/etc/snort
	mkdir -p $RPM_BUILD_ROOT/chroot-snort/var/log/snort/archive
	mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
	make prefix=$RPM_BUILD_ROOT/chroot-snort/usr bindir=$RPM_BUILD_ROOT/chroot-snort/usr/sbin sysconfdir=$RPM_BUILD_ROOT/chroot-snort/etc/snort install
	cd rules
	install \
attack-responses.rules \
backdoor.rules \
bad-traffic.rules \
chat.rules \
ddos.rules \
deleted.rules \
dns.rules \
dos.rules \
experimental.rules \
exploit.rules \
finger.rules \
ftp.rules \
icmp-info.rules \
icmp.rules \
info.rules \
local.rules \
misc.rules \
multimedia.rules \
mysql.rules \
netbios.rules \
nntp.rules \
oracle.rules \
other-ids.rules \
p2p.rules \
policy.rules \
pop2.rules \
pop3.rules \
porn.rules \
rpc.rules \
rservices.rules \
scan.rules \
shellcode.rules \
smtp.rules \
snmp.rules \
sql.rules \
telnet.rules \
tftp.rules \
virus.rules \
web-attacks.rules \
web-cgi.rules \
web-client.rules \
web-coldfusion.rules \
web-frontpage.rules \
web-iis.rules \
web-misc.rules \
web-php.rules \
x11.rules \
	 $RPM_BUILD_ROOT/chroot-snort/etc/snort
	install %{SOURCE1} $RPM_BUILD_ROOT/chroot-snort/usr/bin
	install %{SOURCE2} $RPM_BUILD_ROOT/chroot-snort/usr/bin
	install %{SOURCE4} $RPM_BUILD_ROOT/etc/rc.d/init.d
	cd ..
	install etc/* $RPM_BUILD_ROOT/chroot-snort/etc/snort/ 
#	install classification.config $RPM_BUILD_ROOT/chroot-snort/etc/snort/classification.config
	install contrib/create_mysql $RPM_BUILD_ROOT/chroot-snort/etc/snort
	install contrib/create_oracle.sql $RPM_BUILD_ROOT/chroot-snort/etc/snort
	install contrib/create_postgresql $RPM_BUILD_ROOT/chroot-snort/etc/snort
else
	echo Invalid Build root
	exit 1
fi
rm $RPM_BUILD_ROOT/chroot-snort/usr/man/man8/snort*

%clean
if [ "$RPM_BUILD_ROOT" = "/var/tmp/snort-root" ]; then
	rm -rf $RPM_BUILD_ROOT
else
	echo Invalid Build root
	exit 1
fi
						
%pre
#don't do all this stuff if we are upgrading
if [ $1 = 1 ] ; then
useradd -M -r -d /var/log/snort -s /bin/false -c "Snort" snort 2> /dev/null || true
groupadd -r snort 2> /dev/null || true
fi

%post
#don't do all this stuff if we are upgrading
if [ $1 = 1 ] ; then
/sbin/chkconfig --add snortd-chroot
 mkdir -p /chroot-snort/usr/lib/i686
 mkdir -p /chroot-snort/usr/lib/mysql
 mkdir -p /chroot-snort/lib/i686
 cp /usr/lib/libz.so.1 /chroot-snort/usr/lib/
 cp /lib/i686/libm.so.6 /chroot-snort/lib/i686/
 cp /lib/libnsl.so.1 /chroot-snort/lib/
 cp /usr/lib/mysql/libmysqlclient.so.10 /chroot-snort/usr/lib/mysql/
 cp /lib/i686/libc.so.6 /chroot-snort/usr/lib/i686
 cp /lib/libcrypt.so.1 /chroot-snort/lib/
 cp /lib/ld-linux.so.2 /chroot-snort/lib/
 cp /etc/passwd /chroot-snort/etc/
fi

 
chown snort.snort /chroot-snort/var/log/snort

%preun
/etc/rc.d/init.d/snortd-chroot stop
if [ $1 = 0 ] ; then
/sbin/chkconfig --del snortd-chroot
fi

%postun
#only if we are removing, not upgrading..
if [ $1 = 0 ] ; then
userdel snort 2> /dev/null || true
groupdel snort 2> /dev/null || true
fi

%files
%defattr(-,snort,root)
%doc COPYING LICENSE ChangeLog doc/
%attr(755,snort,root)       /chroot-snort/usr/sbin/*
%attr(755,snort,root) 	   /chroot-snort/usr/bin/*
%attr(750,snort,wheel)  %dir /chroot-snort/var/log/snort
%attr(750,snort,wheel)  %dir /chroot-snort/var/log/snort/archive
%attr(640,snort,wheel) %config(noreplace)     /chroot-snort/etc/snort/*
%attr(750,snort,root)   /etc/rc.d/init.d/snortd-chroot

%changelog
* Sun Apr 13 2003 Ralf Spenneberg <ralf@spenneberg.de>
- changed numbering Scheme to reflect Red Hat 7.3
- moved to Red Hat 7.3 and snort 1.9.1

* Sun Apr 13 2003 Ralf Spenneberg <ralf@spenneberg.de>
- changed numbering Scheme to reflect Red Hat 9
- moved to Red Hat 9 and snort 1.9.1

* Wed Jul 24 2002 Ralf Spenneberg <ralf@spenneberg.de>
- Moved to snort 1.8.7
- chrooted snort to /chroot-snort

* Mon Apr 05 2002 Ralf Spenneberg <ralf@spenneberg.de>
- Moved to snort 1.8.4

* Mon Aug 13 2001 Ralf Spenneberg <ralf@spenneberg.de>
- Added Mysql/Postgresql Support

* Thu Jul 12 2001 Marion Bates <mbates@ists.dartmouth.edu>
- Updated source to 1.8p1. 
- Fixed syntax problem (bad square brackets) with DNS servers in snort.conf.
- Changed process to use and slightly alter stock snort.conf file, instead of creating from scratch.

* Wed Jul 11 2001 William Stearns <wstearns@pobox.com>
- Updated source to 1.8-RELEASE, will later shoot Marty for using -RELEASE.
- Use new X-rules config files instead of old X-lib files

* Sat Jan 06 2001 Wim Vandersmissen <wim@bofh.be>
- Updated to version 1.7
- Some minor changes to snort.conf (uses default ruleset instead of vision rules)

* Tue Jul 25 2000 Wim Vandersmissen <wim@bofh.st>
- Added some checks to find out if we're upgrading or removing the package

* Sat Jul 22 2000 Wim Vandersmissen <wim@bofh.st>
- Updated to version 1.6.3
- Fixed the user/group stuff (moved to %post)
- Added userdel/groupdel to %postun
- Automagically adds the right IP, nameservers to /etc/snort/rules.base

* Sat Jul 08 2000 Dave Wreski <dave@linuxsecurity.com>
- Updated to version 1.6.2
- Removed references to xntpd
- Fixed minor problems with snortd init script

* Fri Jul 07 2000 Dave Wreski <dave@linuxsecurity.com>
- Updated to version 1.6.1
- Added user/group snort

* Sat Jun 10 2000 Dave Wreski <dave@linuxsecurity.com>
- Added snort init.d script (snortd)
- Added Dave Dittrich's snort rules header file (ruiles.base)
- Added Dave Dittrich's wget rules fetch script (check-snort)
- Fixed permissions on /var/log/snort
- Created /var/log/snort/archive for archival of snort logs
- Added post/preun to add/remove snortd to/from rc?.d directories
- Defined configuration files as %config

* Tue Mar 28 2000 William Stearns <wstearns@pobox.com>
- Quick update to 1.6.
- Sanity checks before doing rm-rf in install and clean

* Fri Dec 10 1999 Henri Gomez <gomez@slib.fr>
- 1.5-0 Initial RPM release
